// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "PacketAnalyzer.h"

#include "MainFrm.h"
#include "CaptureDlg.h"

#include "PacketGraphView.h"
#include "PacketHexaView.h"
#include "PacketListView.h"
#include "PacketInfoScrollView.h"
#include "Protocol.h"
#include "pcap.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_COMMAND(ID_PACKET_CAPTURE, OnPacketCapture)
	ON_COMMAND(ID_VIRUS_PORT_INPUT_LIST, OnVirusPortInputList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	m_strInfo = _T("");
	nIndex = 0;
	m_nArpCount = 0;
	m_nIcmpCount = 0;
	m_nTcpCount = 0;
	m_nUdpCount = 0;
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	cs.lpszName = "Packet Analyzer v1.0 TestVersion - happython";
	cs.style &= ~FWS_ADDTOTITLE;
	cs.style ^= WS_MAXIMIZEBOX;
	cs.cx = 1000;
    cs.cy = 720;
	cs.x = 0;
	cs.y = 0;

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	//
	m_wndSplit.CreateStatic(this,1,2);

	m_wndSplit.CreateView(0,0,RUNTIME_CLASS(CPacketInfoScrollView),CSize(0,300),pContext);
	
	m_wndSplit2.CreateStatic(&m_wndSplit,2,1,WS_CHILD | WS_VISIBLE, m_wndSplit.IdFromRowCol(0,1));
	m_wndSplit2.CreateView(0,0,RUNTIME_CLASS(CPacketListView),CSize(0,0),pContext);
	
	m_wndSplit3.CreateStatic(&m_wndSplit2,1,2,WS_CHILD |WS_VISIBLE, m_wndSplit2.IdFromRowCol(1,0));
	m_wndSplit3.CreateView(0,0,RUNTIME_CLASS(CPacketHexaView),CSize(0,0),pContext);
	m_wndSplit3.CreateView(0,1,RUNTIME_CLASS(CPacketGraphView),CSize(0,0),pContext);
	

	m_wndSplit.SetColumnInfo(0, 300, 0);
	m_wndSplit3.SetColumnInfo(0, 400, 0);
	m_wndSplit3.SetRowInfo(0,400,0);
	double nSize;
	nSize = m_nWindowMaxSizeY * 0.45;

	m_wndSplit2.SetRowInfo(0,int(nSize),0);
	
	m_pPacketInfoScrollView = (CPacketInfoScrollView*)m_wndSplit.GetPane(0,0);
	m_pPacketListView = (CPacketListView*)m_wndSplit2.GetPane(0,0);
	m_pPacketHexaView = (CPacketHexaView*)m_wndSplit3.GetPane(0,0);
	m_pPacketGraphView = (CPacketGraphView*)m_wndSplit3.GetPane(0,1);
	
	return TRUE;
	
}

void CMainFrame::OnSize(UINT nType, int cx, int cy) 
{
	CFrameWnd::OnSize(nType, cx, cy);
	// TODO: Add your message handler code here
	m_nWindowMaxSizeY = cy;

	//Invalidate();
}




void CMainFrame::OnPacketCapture() 
{
	// TODO: Add your command handler code here
	CCaptureDlg* m_pCapture = new CCaptureDlg;
	
	m_pCapture->Create(IDD_CAPTURE_DIALOG,this);
	m_pCapture->ShowWindow(SW_SHOW);
	
}




void CMainFrame::SetListView(int Index)
{
	
	nIndex = Index;
	CString strBuff;
	
	CListCtrl& list = m_pPacketListView->GetListCtrl();
	
	//Ʈ 
	strBuff.Format("%d",nIndex);
	list.InsertItem(Index-1,strBuff);
	list.SetItemText(Index-1,1,strProtocol);
	list.SetItemText(Index-1,2,strSrcAddr);
	
	if(nSrcPort == 0)
	{	
		list.SetItemText(Index-1,3,"  ");
	} else {
		strBuff.Format("%d",nSrcPort);
		list.SetItemText(Index-1,3,strBuff);
	}
	
	list.SetItemText(Index-1,4,strDstAddr);
	if(nDstPort == 0)
	{
		list.SetItemText(Index-1,5,"  ");
	} else {
		strBuff.Format("%d",nDstPort);
		list.SetItemText(Index-1,5,strBuff);
	}

	strBuff.Format("%d",nLength);
	list.SetItemText(Index-1,6,strBuff);
	if(m_strInfo != ""){
		list.SetItemText(Index-1,7,m_strInfo);
		m_strInfo = _T("");
	} 
	else if (nSrcPort == 0 || nDstPort == 0){
		m_strInfo.Format("%s >> %s ",strSrcAddr,strDstAddr);
		list.SetItemText(Index-1,7,m_strInfo);
	} else {
		m_strInfo.Format("%s : %d >> %s : %d",strSrcAddr,nSrcPort,strDstAddr,nDstPort);
		list.SetItemText(Index-1,7,m_strInfo);
	}
	
	m_pPacketGraphView->SetGraphView();
}

void CMainFrame::SetListViewClear()
{
	CListCtrl& list = m_pPacketListView->GetListCtrl();
	list.DeleteAllItems();
	Invalidate();
	
}

void CMainFrame::OnVirusPortInputList() 
{
	// TODO: Add your command handler code here
	CVirusPortInputListDlg dlg;
	dlg.DoModal();
	
}
