// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__B51C4C85_2B06_4E5B_9156_3ACCC9BFF1BE__INCLUDED_)
#define AFX_MAINFRM_H__B51C4C85_2B06_4E5B_9156_3ACCC9BFF1BE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "FlatSplitterWnd.h"
#include "PacketListView.h"
#include "PacketHexaView.h"
#include "PacketGraphView.h"
#include "PacketInfoScrollView.h"
#include "CaptureDlg.h"
#include "VirusPortInputListDlg.h"

 
class CMainFrame : public CFrameWnd
{
	
protected: // create from serialization only
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)

// Attributes
public:
	CPacketListView*		m_pPacketListView;
	CPacketInfoScrollView*	m_pPacketInfoScrollView;
	CPacketHexaView*		m_pPacketHexaView;
	CPacketGraphView*		m_pPacketGraphView;;
	
	CList<PACKET_DATA,PACKET_DATA&>	g_PacketDataList;

// Operations
public:
	
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext);
	//}}AFX_VIRTUAL

// Implementation
public:
	int m_nArpCount;
	int m_nIcmpCount;
	int m_nUdpCount;
	int m_nTcpCount;
	void SetListViewClear();
	CString m_strInfo;

	UINT nEtherType;
	//UINT nLength;
	bpf_u_int32 nLength;
	UINT nDstPort;
	CString strDstAddr;
	UINT nSrcPort;
	CString strSrcAddr;
	CString strProtocol;
	int nIndex;
	
	void SetListView(int Index);
	
	int m_nWindowMaxSizeY;
	virtual ~CMainFrame();
	CFlatSplitterWnd m_wndSplit;
	CFlatSplitterWnd m_wndSplit2;
	CFlatSplitterWnd m_wndSplit3;
	

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnPacketCapture();
	afx_msg void OnVirusPortInputList();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__B51C4C85_2B06_4E5B_9156_3ACCC9BFF1BE__INCLUDED_)
