// PacketHexaView.cpp : implementation file
//

#include "stdafx.h"
#include "PacketAnalyzer.h"
#include "PacketHexaView.h"
#include "MainFrm.h"
#include "Protocol.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPacketHexaView

IMPLEMENT_DYNCREATE(CPacketHexaView, CView)

CPacketHexaView::CPacketHexaView()
{
	m_nSrcPort = 0;
	m_nDstPort = 0;
	
	m_hbrBrush.CreateSolidBrush(RGB(255,255,255)); 
}

CPacketHexaView::~CPacketHexaView()
{
}


BEGIN_MESSAGE_MAP(CPacketHexaView, CView)
	//{{AFX_MSG_MAP(CPacketHexaView)
	ON_WM_SIZE()
	ON_WM_CREATE()
	//ON_WM_CTLCOLOR()
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPacketHexaView drawing

void CPacketHexaView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: add draw code here
	CRect rect,rcClient;
	GetClientRect(rcClient);

//	pDC->FillSolidRect(rcClient,233+233*256+233*256*256);

//	return;
	COLORREF crLight = GetSysColor(COLOR_BTNHIGHLIGHT);
	COLORREF crShadow = GetSysColor(COLOR_BTNSHADOW);
	COLORREF crBtnFace = GetSysColor(COLOR_BTNFACE);

	pDC->SetBkMode(TRANSPARENT);
	CGdiObject *pOldFont = pDC->SelectStockObject(ANSI_VAR_FONT);

	rect = rcClient;

	// 1st rect
	rect.bottom = rect.top + 22;
	pDC->FillSolidRect(rect,crBtnFace);
	pDC->Draw3dRect(rect,crLight,crShadow);
	pDC->DrawText("   Packet Capture",rect,DT_SINGLELINE|DT_VCENTER);
	
	rect.OffsetRect(0,22);
	pDC->FillSolidRect(rect,crBtnFace);
	pDC->Draw3dRect(rect,crLight,crShadow);
	pDC->DrawText("Hexa Code View",rect,DT_SINGLELINE|DT_VCENTER|DT_CENTER);
	
	// White rect

	rect.top = rect.bottom;
	rect.bottom = rcClient.bottom;
	pDC->FillSolidRect(rect,RGB(255,255,255));
	pDC->Draw3dRect(rect,crLight,crShadow);

	pDC->SelectObject(pOldFont);
	
	
}

/////////////////////////////////////////////////////////////////////////////
// CPacketHexaView diagnostics

#ifdef _DEBUG
void CPacketHexaView::AssertValid() const
{
	CView::AssertValid();
}

void CPacketHexaView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPacketHexaView message handlers

void CPacketHexaView::SetHexaView(int nIndex,int nLength)
{
	
	CMainFrame *pFrame = (CMainFrame *)AfxGetMainWnd();
	
	m_nIndex = nIndex;
	m_nLength = nLength;

	CString str;
	str.Format("%d",nIndex);
	PACKET_DATA		sPacket(str);
	POSITION		pos = pFrame->g_PacketDataList.Find(sPacket);

	PACKET_DATA*	pPacketData = &(pFrame->g_PacketDataList.GetAt(pos));
	
	pPacket = (u_char*)pPacketData->packetdata;
	
	//HEXA ڵ 
	int i;
	
	CString strBuff = " ";
	CString strtotal;
	m_wndEdit.SetWindowText(strBuff);
	
	for (i=1; (i < nLength + 1 ) ; i++)
	{
		strBuff.Format("%02X ", pPacket[i-1]);
		strtotal += strBuff;
				
		if ( (i % 16) == 0) {
			strtotal += "\r\n";
		} 
	}
	m_wndEdit.SetWindowText(strtotal);
	UpdateData(FALSE);
}

void CPacketHexaView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	m_wndEdit.MoveWindow(1,44,cx-2,cy-45);
	
	// TODO: Add your message handler code here
	
}

int CPacketHexaView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	//if (CView::OnCreate(lpCreateStruct) == -1)
	//	return -1;
	m_wndEdit.Create(WS_VISIBLE|WS_CHILD|ES_MULTILINE|WS_VSCROLL|ES_AUTOVSCROLL,CRect(0,0,0,0),this,0);
	
	CFont font;
	font.CreateStockObject(ANSI_FIXED_FONT);
	
	m_wndEdit.SetFont(&font);
	m_wndEdit.SetReadOnly(TRUE);
	// TODO: Add your specialized creation code here
	
	
	return 0;
}

HBRUSH CPacketHexaView::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CView::OnCtlColor(pDC, pWnd, nCtlColor);
	
	pDC->SetBkMode(TRANSPARENT);
	return (HBRUSH)m_hbrBrush;
	
	//return hbr;
}

BOOL CPacketHexaView::OnEraseBkgnd(CDC* pDC) 
{
	// TODO: Add your message handler code here and/or call default
	
	//return CView::OnEraseBkgnd(pDC);
	return 1;
}
