// PacketInfoScrollView.cpp : implementation file
//

#include "stdafx.h"
#include "PacketAnalyzer.h"
#include "PacketInfoScrollView.h"
#include "MainFrm.h"
#include "Protocol.h"
#include "WINSOCK2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPacketInfoScrollView

IMPLEMENT_DYNCREATE(CPacketInfoScrollView, CScrollView)

CPacketInfoScrollView::CPacketInfoScrollView()
{
	m_bInfoStatus = FALSE;
	m_nMaxSize = 100;
}

CPacketInfoScrollView::~CPacketInfoScrollView()
{
}


BEGIN_MESSAGE_MAP(CPacketInfoScrollView, CScrollView)
	//{{AFX_MSG_MAP(CPacketInfoScrollView)
	ON_WM_CREATE()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPacketInfoScrollView drawing

void CPacketInfoScrollView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

	CSize sizeTotal;
	// TODO: calculate the total size of this view
	sizeTotal.cx = 100;
	sizeTotal.cy = m_nMaxSize;
	SetScrollSizes(MM_TEXT, sizeTotal);
}

void CPacketInfoScrollView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code here
	CRect rect,rcClient;
	GetClientRect(rcClient);

//	pDC->FillSolidRect(rcClient,233+233*256+233*256*256);

//	return;
	COLORREF crLight = GetSysColor(COLOR_BTNHIGHLIGHT);
	COLORREF crShadow = GetSysColor(COLOR_BTNSHADOW);
	COLORREF crBtnFace = GetSysColor(COLOR_BTNFACE);

	pDC->SetBkMode(TRANSPARENT);
	CGdiObject *pOldFont = pDC->SelectStockObject(ANSI_VAR_FONT);

	rect = rcClient;

	// 1st rect
	rect.bottom = rect.top + 22;
	pDC->FillSolidRect(rect,crBtnFace);
	pDC->Draw3dRect(rect,crLight,crShadow);
	pDC->DrawText("   Packet Capture",rect,DT_SINGLELINE|DT_VCENTER);
	
	// 2nd rect
	rect.OffsetRect(0,22);
	pDC->FillSolidRect(rect,crBtnFace);
	pDC->Draw3dRect(rect,crLight,crShadow);
	pDC->DrawText("Information View",rect,DT_SINGLELINE|DT_VCENTER|DT_CENTER);
	
	// White rect
	rect.top = rect.bottom;
	if(rcClient.bottom >= m_nMaxSize){
		rect.bottom = rcClient.bottom;
	} else {
		rect.bottom = m_nMaxSize;
	}
	pDC->FillSolidRect(rect,RGB(255,255,255));
	pDC->Draw3dRect(rect,crLight,crShadow);
	pDC->SelectObject(pOldFont);
	
	
	if(m_bInfoStatus == TRUE)
	{
		CMainFrame *pFrame = (CMainFrame *)AfxGetMainWnd();
	
		CString str;
		str.Format("%d",m_nIndex);
	
		PACKET_DATA		sPacket(str);
		POSITION		pos = pFrame->g_PacketDataList.Find(sPacket);

		PACKET_DATA*	pPacketData = &(pFrame->g_PacketDataList.GetAt(pos));
	
		u_char *pPacket = (u_char*)pPacketData->packetdata;

		ETHER_HEADER*	pEtherHeader = NULL;
		ushort_t		nEtherType = 0;
		char			sBuffer[128];
	
		pEtherHeader = (ETHER_HEADER*)pPacket;
		pPacket += sizeof(ETHER_HEADER);
		nEtherType = ntohs(pEtherHeader->ether_type);

		//=============================================================================//
		//Ethernet Herader Format ǥ												   //
		//=============================================================================//	
			
		// Ʈ
		CFont font;
		font.CreatePointFont(80,"Arial");
	
		//ũ  Ʈ	
		CGdiObject *pOldFont = pDC->SelectStockObject(ANSI_VAR_FONT);

		pDC->SelectObject(pOldFont);
		pDC->TextOut(10,55,"Ethernet Header");
	
		pDC->Rectangle(10,80,270,130);
		pDC->MoveTo(110,80);
		pDC->LineTo(110,130);
		pDC->MoveTo(210,80);
		pDC->LineTo(210,130);
	
		pDC->TextOut(13,83,"Destination");
		pDC->TextOut(113,83,"Source");
		pDC->TextOut(213,83,"Type");
		//=============================================================================//

		//destination MAC
		sprintf(sBuffer,"%02X %02X %02X %02X %02X %02X",
			pEtherHeader->ether_dhost.ether_addr_octet[0],
			pEtherHeader->ether_dhost.ether_addr_octet[1],
			pEtherHeader->ether_dhost.ether_addr_octet[2],
			pEtherHeader->ether_dhost.ether_addr_octet[3],
			pEtherHeader->ether_dhost.ether_addr_octet[4],
			pEtherHeader->ether_dhost.ether_addr_octet[5]);
	
	
		//=============================================================================//
		pDC->SelectObject(&font);
		pDC->TextOut(15,110,sBuffer);
		//=============================================================================//
	
		//Source MAC
		sprintf(sBuffer,"%02X %02X %02X %02X %02X %02X",
			pEtherHeader->ether_shost.ether_addr_octet[0],
			pEtherHeader->ether_shost.ether_addr_octet[1],
			pEtherHeader->ether_shost.ether_addr_octet[2],
			pEtherHeader->ether_shost.ether_addr_octet[3],
			pEtherHeader->ether_shost.ether_addr_octet[4],
			pEtherHeader->ether_shost.ether_addr_octet[5]);
	
		//=============================================================================//
		pDC->TextOut(115,110,sBuffer);
		//=============================================================================//
	
		//Type
		sprintf(sBuffer,"0x%04x",nEtherType);
		switch (nEtherType){
			case ETHERTYPE_IP :
				str = "IP";
				break;
			case ETHERTYPE_ARP :
				str = "ARP";
				break;
			case ETHERTYPE_REVARP :
				str = "RARP";
				break;
		}
		
		//=============================================================================//
		pDC->TextOut(215,105,str);
		pDC->TextOut(215,115,sBuffer);
		//=============================================================================//
	
		pDC->SelectObject(pOldFont);
	
		if(nEtherType == ETHERTYPE_IP) 
		{
			//=============================================================================//
			//IP Header Format	ǥ														   //
			//=============================================================================//
			pDC->SelectObject(pOldFont);
			pDC->TextOut(10,155,"IP header - Internet Protocol");
			pDC->Rectangle(10,180,270,430);
	
			pDC->MoveTo(10,230); pDC->LineTo(270,230);
			pDC->MoveTo(10,280); pDC->LineTo(270,280);
			pDC->MoveTo(10,330); pDC->LineTo(270,330);
			pDC->MoveTo(10,380); pDC->LineTo(270,380);
	
			pDC->MoveTo(43,180); pDC->LineTo(43,230);
			pDC->MoveTo(76,180); pDC->LineTo(76,230);
			pDC->MoveTo(142,180); pDC->LineTo(142,330);
			pDC->MoveTo(175,230); pDC->LineTo(175,280);

			pDC->MoveTo(76,280); pDC->LineTo(76,330);

			pDC->TextOut(13,183,"Ver.");	
			pDC->TextOut(46,183,"Len.");
			pDC->TextOut(80,183,"TOS");
			pDC->TextOut(147,183,"Total Length");
	
			pDC->TextOut(15,235,"Identification");
			pDC->TextOut(145,235,"Flag");
			pDC->TextOut(178,235,"Fragment off.");
	
			pDC->TextOut(15,285,"TTL");
			pDC->TextOut(80,285,"Protocol");
			pDC->TextOut(147,285,"CheckSum");

			pDC->TextOut(15,335,"Source IP");
			pDC->TextOut(15,385,"Destination IP");
			//=============================================================================//

			IP_HEADER* pIPHeader = (IP_HEADER*)pPacket;
		
			//IP version
			sprintf(sBuffer,"%u",pIPHeader->ip_v);
			//=============================================================================//
			pDC->SelectObject(&font);
			pDC->TextOut(15,210,sBuffer);
			//=============================================================================//
		
			//header length
			sprintf(sBuffer,"%u",pIPHeader->ip_hl * 4);
			//=============================================================================//
			pDC->TextOut(48,210,sBuffer);	
			//=============================================================================//
		
			//TOS
			sprintf(sBuffer,"0x%02X",pIPHeader->ip_tos);
			//=============================================================================//
			pDC->TextOut(81,210,sBuffer);
			//=============================================================================//

			//total length
			sprintf(sBuffer,"%u",ntohs(pIPHeader->ip_len));
			//=============================================================================//
			pDC->TextOut(150,210,sBuffer);
			//=============================================================================//
	
			//identification
			sprintf(sBuffer,"%d",ntohs(pIPHeader->ip_id));
			//=============================================================================//
			pDC->TextOut(15,260,sBuffer);	
			//=============================================================================//

			//flags
			short ip_off = ntohs(pIPHeader->ip_off);
			sprintf(sBuffer,"[DF] %d",(ip_off & IP_DF) == IP_DF);
			//=============================================================================//
			pDC->TextOut(145,255,sBuffer);	
			//=============================================================================//

			sprintf(sBuffer,"[MF]%d",(ip_off & IP_MF) == IP_MF);
			//=============================================================================//
			pDC->TextOut(145,265,sBuffer);
			//=============================================================================//
			
			//Fragment offset
			sprintf(sBuffer,"%d",(ip_off & IP_OFFMASK) * 8);
			//=============================================================================//
			pDC->TextOut(180,260,sBuffer);
			//=============================================================================//
		
			//TTL
			sprintf(sBuffer,"%d",pIPHeader->ip_ttl);
			//=============================================================================//
			pDC->TextOut(15,310,sBuffer);
			//=============================================================================//

			//Protocol
			sprintf(sBuffer,"%s [0x%02X]",m_strProtocol,pIPHeader->ip_p);
			//=============================================================================//
			pDC->TextOut(80,310,sBuffer);
			//=============================================================================//
		
			//checksum
			sprintf(sBuffer,"0x%04X",ntohs(pIPHeader->ip_sum));
			//=============================================================================//
			pDC->TextOut(150,310,sBuffer);
			//=============================================================================//
		
			//source IP
			sprintf(sBuffer,"%s",inet_ntoa(pIPHeader->ip_src));
			//=============================================================================//
			pDC->TextOut(15,360,sBuffer);
			//=============================================================================//
		
			//Destination IP
			sprintf(sBuffer,"%s",inet_ntoa(pIPHeader->ip_dst));
			//=============================================================================//
			pDC->TextOut(15,410,sBuffer);
			//=============================================================================//
			UpdateData(FALSE);
			//TCP
			if(pIPHeader->ip_p == IPPROTO_TCP)
			{
			
				//=============================================================================//
				//TCP Header Format ǥ													   //
				//=============================================================================//
				pDC->SelectObject(pOldFont);
				pDC->TextOut(10,455,"TCP Header -");
				pDC->Rectangle(10,480,270,730);
				pDC->MoveTo(10,530); pDC->LineTo(270,530);
				pDC->MoveTo(10,580); pDC->LineTo(270,580);
				pDC->MoveTo(10,630); pDC->LineTo(270,630);
				pDC->MoveTo(10,680); pDC->LineTo(270,680);
	
				pDC->MoveTo(140,480); pDC->LineTo(140,530);
	
				pDC->MoveTo(45,630); pDC->LineTo(45,680);
				pDC->MoveTo(140,630); pDC->LineTo(140,730);

				pDC->TextOut(13,483,"Source Port");
				pDC->TextOut(143,483,"Destination Port");
				pDC->TextOut(13,533,"Sequence Number");
				pDC->TextOut(13,583,"Acknowledgement Number");
				pDC->TextOut(13,633,"Len.");
				pDC->TextOut(48,633,"Flags");
				pDC->TextOut(143,633,"Window");
				pDC->TextOut(13,683,"Checksum");
				pDC->TextOut(143,683,"Urgent Pointer");

				//ũѹ  
				m_nMaxSize = 750;
				//this->OnInitialUpdate();
				UpdateData(FALSE);
				
				//=============================================================================//
		
				TCP_HEADER*		pTCPHeader = (TCP_HEADER*)(pPacket + pIPHeader->ip_hl * 4);
				
				//Source Port
				sprintf(sBuffer,"%u",ntohs(pTCPHeader->th_sport));
				//=============================================================================//
				pDC->SelectObject(&font);
				pDC->TextOut(110,458,"Transmission Control Protocol");
				pDC->TextOut(13,510,sBuffer);
				//=============================================================================//

				//Destination Port
				sprintf(sBuffer,"%u",ntohs(pTCPHeader->th_dport));
				//=============================================================================//
				pDC->TextOut(145,510,sBuffer);
				//=============================================================================//

				//Sequence Number
				sprintf(sBuffer,"%u",ntohs(pTCPHeader->th_seq));
				//=============================================================================//
				pDC->TextOut(15,560,sBuffer);
				//=============================================================================//
			
				//Acknowledgement Number
				sprintf(sBuffer,"%u",ntohs(pTCPHeader->th_ack));
				//=============================================================================//
				pDC->TextOut(15,610,sBuffer);
				//=============================================================================//
			
				//Header Length
				sprintf(sBuffer,"%d",pTCPHeader->th_off * 4);
				//=============================================================================//
				pDC->TextOut(15,660,sBuffer);
				//=============================================================================//

				//Flags
				sprintf(sBuffer,"0x%02X",pTCPHeader->th_flags);
				switch (pTCPHeader->th_flags) {
					case TH_FIN :
						sprintf(sBuffer,"0x%02X [ FIN ]",pTCPHeader->th_flags);
						break;
					case TH_SYN :
						sprintf(sBuffer,"0x%02X [ SYN ]",pTCPHeader->th_flags);
						break;
					case TH_RST :
						sprintf(sBuffer,"0x%02X [ RST ]",pTCPHeader->th_flags);
						break;
					case TH_PUSH :
						sprintf(sBuffer,"0x%02X [ PUSH ]",pTCPHeader->th_flags);
						break;
					case TH_ACK :
						sprintf(sBuffer,"0x%02X [ ACK ]",pTCPHeader->th_flags);
						break;
					case TH_URG :
						sprintf(sBuffer,"0x%02X [ URG ]",pTCPHeader->th_flags);
						break;
					case TH_ECE :
						sprintf(sBuffer,"0x%02X [ ECE ]",pTCPHeader->th_flags);
						break;
					case TH_CWR :
						sprintf(sBuffer,"0x%02X [ CWR ]",pTCPHeader->th_flags);
						break;
					case TH_PSHACK :
						sprintf(sBuffer,"0x%02X [ PSH, ACK ]",pTCPHeader->th_flags);
						break;
				}
				//=============================================================================//
				pDC->TextOut(50,660,sBuffer);
				//=============================================================================//
			
				//Window
				sprintf(sBuffer,"%u",ntohs(pTCPHeader->th_win));
				//=============================================================================//
				pDC->TextOut(145,660,sBuffer);
				//=============================================================================//

				//Checksum
				sprintf(sBuffer,"0x%04X",ntohs(pTCPHeader->th_sum));
				//=============================================================================//
				pDC->TextOut(15,710,sBuffer);
				//=============================================================================//

				//Urgent Pointer
				sprintf(sBuffer,"0x%04X",ntohs(pTCPHeader->th_urp));
				//=============================================================================//
				pDC->TextOut(145,710,sBuffer);
				//=============================================================================//
				UpdateData(FALSE);
			}
			else if(pIPHeader->ip_p == IPPROTO_UDP)
			{
				//=============================================================================//
				//UDP Header Format ǥ
				//=============================================================================//
				pDC->SelectObject(pOldFont);
				pDC->TextOut(10,455,"UDP Header - User Datagram Protocol");
				pDC->Rectangle(10,480,270,580);
				pDC->MoveTo(10,530); pDC->LineTo(270,530);
				pDC->MoveTo(140,480); pDC->LineTo(140,580);
	
				pDC->TextOut(13,483,"Source Port");
				pDC->TextOut(143,483,"Destination Port");
				pDC->TextOut(13,533,"Length");
				pDC->TextOut(143,533,"Checksum");
				//=============================================================================//

				UDP_HEADER*		pUDPHeader = (UDP_HEADER*)(pPacket + pIPHeader->ip_hl * 4);	
			
				//Source Port
				sprintf(sBuffer,"%u",ntohs(pUDPHeader->uh_sport));
				//=============================================================================//
				pDC->SelectObject(&font);
				pDC->TextOut(15,510,sBuffer);
				//=============================================================================//
				
				//Destination Port
				sprintf(sBuffer,"%u",ntohs(pUDPHeader->uh_dport));
				//=============================================================================//
				pDC->TextOut(145,510,sBuffer);
				//=============================================================================//

				//Length
				sprintf(sBuffer,"%d",ntohs(pUDPHeader->uh_ulen));
				//=============================================================================//
				pDC->TextOut(15,560,sBuffer);
				//=============================================================================//

				//Checksum
				sprintf(sBuffer,"0x%04X",ntohs(pUDPHeader->uh_sum));
				//=============================================================================//
				pDC->TextOut(145,560,sBuffer);
				//=============================================================================//	
				UpdateData(FALSE);
			}
			else if (pIPHeader->ip_p == IPPROTO_ICMP)
			{
				//=============================================================================//
				//ICMP header Format ǥ													   //
				//=============================================================================//
				pDC->SelectObject(pOldFont);
				pDC->TextOut(10,455,"ICMP Header -");

				pDC->Rectangle(10,480,270,530);
	
				pDC->MoveTo(75,480); pDC->LineTo(75,530);
				pDC->MoveTo(140,480); pDC->LineTo(140,530);
		
				pDC->TextOut(13,483,"Type");
				pDC->TextOut(78,483,"Code");
				pDC->TextOut(143,483,"Checksum");

				pDC->SelectObject(&font);
				pDC->TextOut(110,458,"Internet Control Message Protocol");
				//=============================================================================//

				ICMP_HEADER* pICMPHeader = (ICMP_HEADER*)(pPacket + pIPHeader->ip_hl * 4);

				//Type
				sprintf(sBuffer,"%d",pICMPHeader->type);
				//=============================================================================//
				pDC->TextOut(15,505,sBuffer);
				switch(pICMPHeader->type) 
				{
					case 0 :
							pDC->TextOut(15,515,"Echo Reply");
							break;
					case 3 :
							pDC->TextOut(15,515,"Destination Unreachable");
							break;
					case 4 :
							pDC->TextOut(15,515,"Source Quench");
							break;
					case 5 :
							pDC->TextOut(15,515,"Redirect(change route)");
							break;
					case 8 :
							pDC->TextOut(11,515,"Echo Request");
							break;
					case 11:
							pDC->TextOut(15,515,"Time Exceeded");
							break;
					case 12 :
							pDC->TextOut(15,515,"Parameter Problem");
							break;
					case 13 :
							pDC->TextOut(15,515,"Timestamp Request");
							break;
					case 14 :
							pDC->TextOut(15,515,"Timestamp Reply");
							break;
					case 15 :
							pDC->TextOut(15,515,"Information Request");
							break;
					case 16 :
							pDC->TextOut(15,515,"Information Reply");
							break;
					case 17 :
							pDC->TextOut(15,515,"Address Mask Request");
							break;
					case 18 :
							pDC->TextOut(15,515,"Address Mask Reply");
							break;
				} 

			
				//=============================================================================//
			
				//Code
				sprintf(sBuffer,"%d",ntohs(pICMPHeader->code));
				//=============================================================================//
				pDC->TextOut(80,510,sBuffer);
				//=============================================================================//
			
				//Checksum
				sprintf(sBuffer,"0x%04X",ntohs(pICMPHeader->checksum));
				//=============================================================================//
				pDC->TextOut(145,510,sBuffer);
				//=============================================================================//
				UpdateData(FALSE);		
			}
		}
		else if ((nEtherType == ETHERTYPE_ARP) || (nEtherType == ETHERTYPE_REVARP))
		{
			//=============================================================================//
			//ARP, RARP Header Format ǥ
			//=============================================================================//
			pDC->SelectObject(pOldFont);
			if(nEtherType == ETHERTYPE_ARP){
				pDC->TextOut(10,155,"ARP Header -");
				pDC->SelectObject(&font);
				pDC->TextOut(100,157,"Address Resolution Protocol");;
			} 
			else if (nEtherType == ETHERTYPE_REVARP){
				pDC->SelectObject(pOldFont);
				pDC->TextOut(10,155,"RARP Header -");
				pDC->SelectObject(&font);
				pDC->TextOut(105,157,"Reverse Address Resolution Protocol");
			}
			pDC->SelectObject(pOldFont);
			pDC->MoveTo(10,180); pDC->LineTo(218,180);
			pDC->MoveTo(10,180); pDC->LineTo(10,230);	
			pDC->MoveTo(62,180); pDC->LineTo(62,230);
			pDC->MoveTo(114,180); pDC->LineTo(114,230);
			pDC->MoveTo(140,180); pDC->LineTo(140,230);
	
			pDC->MoveTo(218,180); pDC->LineTo(218,230);

			pDC->Rectangle(10,230,270,330);
			pDC->MoveTo(10,280); pDC->LineTo(270,280);	
			pDC->MoveTo(166,180); pDC->LineTo(166,330);

			pDC->TextOut(13,183,"H.Type");
			pDC->TextOut(65,183,"P.Type");
			pDC->TextOut(117,183,"1");
			pDC->TextOut(143,183,"2");
			pDC->TextOut(169,183,"Op");
			pDC->TextOut(13,233,"Send MAC Address");
			pDC->TextOut(169,233,"Send IP Addr");
			pDC->TextOut(13,283,"Target MAC Address");	
			pDC->TextOut(169,283,"Target IP Addr");
	
			pDC->TextOut(15,340,"1 : Hardware Size");
			pDC->TextOut(15,355,"2 : Protocol Size");
			pDC->TextOut(15,375,"H.Type : Hardware Type");
			pDC->TextOut(15,390,"P.Type : Protocol Type");
			pDC->TextOut(15,405,"Op : Operation Code");
			//=============================================================================//

			ARP_HEADER*	pARPHeader = (ARP_HEADER*)pPacket;
		
			//Hardware Type
			sprintf(sBuffer,"0x%04X",ntohs(pARPHeader->ar_hrd));
			//=============================================================================//
			pDC->SelectObject(&font);
			pDC->TextOut(15,210,sBuffer);
			//=============================================================================//
		
			//Protocol Type
			sprintf(sBuffer,"0x%04X",ntohs(pARPHeader->ar_pro));
			//=============================================================================//
			pDC->TextOut(67,210,sBuffer);
			//=============================================================================//
		
			//Hardware Size
			sprintf(sBuffer,"%u",pARPHeader->ar_hln);
			//=============================================================================//
			pDC->TextOut(119,210,sBuffer);
			//=============================================================================//
	
			//Protocol Size
			sprintf(sBuffer,"%u",pARPHeader->ar_pln);
			//=============================================================================//
			pDC->TextOut(145,210,sBuffer);
			//=============================================================================//

			//Operation Code
			u_short operation = ntohs(pARPHeader->ar_op);
		
			//=============================================================================//
			if(operation == ARPOP_REQUEST){
				pDC->TextOut(171,215,"Request");
			}
			else if (operation == ARPOP_REPLY){
				pDC->TextOut(171,215,"Reply");
			}
			else if (operation == ARPOP_REVREQUEST){
				pDC->TextOut(171,215,"RevRquest");
			}
			else if (operation == ARPOP_REVREPLY){
				pDC->TextOut(171,215,"RevReply");
			}
			sprintf(sBuffer,"0x%04X",ntohs(operation));
			pDC->TextOut(171,204,sBuffer);
			//=============================================================================//
	
			//Send Mac Addr
			sprintf(sBuffer,"%02X %02X %02X %02X %02X %02X",pARPHeader->ar_sha[0],
				pARPHeader->ar_sha[1],pARPHeader->ar_sha[2],pARPHeader->ar_sha[3],
				pARPHeader->ar_sha[4],pARPHeader->ar_sha[5]);
			//=============================================================================//
			pDC->TextOut(15,260,sBuffer);
			//=============================================================================//
		
			//Send IP addr
			struct in_addr arp_sip;
			memcpy(&arp_sip,pARPHeader->ar_spa,4);
			sprintf(sBuffer,"%s",inet_ntoa(arp_sip));
			//=============================================================================//
			pDC->TextOut(171,260,sBuffer);
			//=============================================================================//

		
			//Target mac Addr
			sprintf(sBuffer,"%02X %02X %02X %02X %02X %02X ",pARPHeader->ar_tha[0],
				pARPHeader->ar_tha[1],pARPHeader->ar_tha[2],pARPHeader->ar_tha[3],
				pARPHeader->ar_tha[4],pARPHeader->ar_tha[5]);
			//=============================================================================//
			pDC->TextOut(15,310,sBuffer);
			//=============================================================================//

			//Target IP Addr
			struct in_addr arp_dip;
			memcpy(&arp_dip,pARPHeader->ar_tpa,4);
			sprintf(sBuffer,"%s",inet_ntoa(arp_dip));
			//=============================================================================//
			pDC->TextOut(171,310,sBuffer);
			//=============================================================================//

		}
	}
	
}

/////////////////////////////////////////////////////////////////////////////
// CPacketInfoScrollView diagnostics

#ifdef _DEBUG
void CPacketInfoScrollView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CPacketInfoScrollView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPacketInfoScrollView message handlers

int CPacketInfoScrollView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CScrollView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	
	return 0;
}



void CPacketInfoScrollView::PacketHeaderView(int index, CString protocol)
{
	CSize sizeTotal;
	// TODO: calculate the total size of this view
	sizeTotal.cx = 100;
	if(protocol == "TCP"){
		sizeTotal.cy = 750;
		m_nMaxSize = 750;
	} else {
		sizeTotal.cy = 100;
	}
	SetScrollSizes(MM_TEXT, sizeTotal);
	
	
	m_nIndex = index;
	m_strProtocol = protocol;
	m_bInfoStatus = TRUE;
	
	Invalidate(FALSE);
	
}

void CPacketInfoScrollView::ClearInfoView()
{
	m_bInfoStatus = FALSE;
	Invalidate(FALSE);
	UpdateData(FALSE);
}

void CPacketInfoScrollView::OnSize(UINT nType, int cx, int cy) 
{
	CScrollView::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	
}
