// PacketListView.cpp : implementation of the CPacketListView class
//

#include "stdafx.h"
#include "PacketAnalyzer.h"

#include "PacketAnalyzerDoc.h"
#include "PacketListView.h"
#include "MainFrm.h"

#include "pcap.h"
#include "WINSOCK2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPacketListView

IMPLEMENT_DYNCREATE(CPacketListView, CListView)

BEGIN_MESSAGE_MAP(CPacketListView, CListView)
	//{{AFX_MSG_MAP(CPacketListView)
	ON_WM_CREATE()
	ON_NOTIFY_REFLECT(LVN_ITEMCHANGED, OnItemchanged)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CListView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CListView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CListView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPacketListView construction/destruction

CPacketListView::CPacketListView()
{
	// TODO: add construction code here
	
}

CPacketListView::~CPacketListView()
{
}

BOOL CPacketListView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	cs.style &= ~LVS_TYPEMASK;
	cs.style |= LVS_REPORT;

	return CListView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CPacketListView drawing

void CPacketListView::OnDraw(CDC* pDC)
{
	CPacketAnalyzerDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
	pDC->TextOut(10,10,"11!");
}

void CPacketListView::OnInitialUpdate()
{
	CListView::OnInitialUpdate();
	// TODO: You may populate your ListView with items by directly accessing
	//  its list control through a call to GetListCtrl().
	CListCtrl& list = GetListCtrl();	
	//ʱȭ
	list.InsertColumn(0,"No",LVCFMT_LEFT,50,0);
	list.InsertColumn(1,"Protocol",LVCFMT_LEFT,80,0);
	list.InsertColumn(2,"Source IP",LVCFMT_LEFT,120,0);
	list.InsertColumn(3,"Port",LVCFMT_LEFT,50,0);
	list.InsertColumn(4,"Destination IP",LVCFMT_LEFT,120,0);
	list.InsertColumn(5,"Port",LVCFMT_LEFT,50,0);
	list.InsertColumn(6,"Length",LVCFMT_LEFT,70,0);
	list.InsertColumn(7,"Information",LVCFMT_LEFT,280,0);
	
	list.SetExtendedStyle(LVS_EX_FULLROWSELECT);
}

/////////////////////////////////////////////////////////////////////////////
// CPacketListView printing

BOOL CPacketListView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CPacketListView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CPacketListView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CPacketListView diagnostics

#ifdef _DEBUG
void CPacketListView::AssertValid() const
{
	CListView::AssertValid();
}

void CPacketListView::Dump(CDumpContext& dc) const
{
	CListView::Dump(dc);
}

CPacketAnalyzerDoc* CPacketListView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPacketAnalyzerDoc)));
	return (CPacketAnalyzerDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPacketListView message handlers


void CPacketListView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	// TODO: Add your specialized code here and/or call the base class
	
}


int CPacketListView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	lpCreateStruct->style = LVS_REPORT;
	if (CListView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	//InitListHeader();
	
	return 0;
}

void CPacketListView::OnItemchanged(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CMainFrame *pFrame = (CMainFrame *)AfxGetMainWnd();
	CListCtrl& list = GetListCtrl();
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here
		
	if(pNMListView->uChanged & LVIF_STATE){
		if(pNMListView->uNewState & (LVIS_SELECTED|LVIS_FOCUSED)){
			CString strIndex = list.GetItemText(pNMListView->iItem,0);
			CString strLength = list.GetItemText(pNMListView->iItem,6);
			CString strProtocol = list.GetItemText(pNMListView->iItem,1);
			
			//info view, hexa view   
			pFrame->m_pPacketInfoScrollView->ClearInfoView();
			pFrame->m_pPacketInfoScrollView->PacketHeaderView(atoi(strIndex),strProtocol);
			pFrame->m_pPacketHexaView->SetHexaView(atoi(strIndex),atoi(strLength));
			


		}
	}
	
	*pResult = 0;
}
